/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rumprobierei;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

/**
 *
 * @author lesasch
 */
public class XMLFile {

    private final String xml;

    private final String encoding;
    private DocumentBuilderFactory factory
            = DocumentBuilderFactory.newInstance();
    private DocumentBuilder builder;

    public XMLFile(String filename) throws FileNotFoundException, IOException, ParserConfigurationException {
        File f = new File(filename);
        // Große Datei - so nicht...
        byte[] buf = new byte[(int) f.length()];
        FileInputStream fis = new FileInputStream(f);
        fis.read(buf);
        fis.close();
        String temp = new String(buf, "UTF-8");
        int a = temp.indexOf("encoding=") + "encoding=".length() + 1;
        int b = temp.indexOf(temp.charAt(a - 1), a);
        encoding = temp.substring(a, b);
        xml = new String(buf, encoding);
        builder = factory.newDocumentBuilder();
        factory.setNamespaceAware(false);
        factory.setIgnoringComments(false);
    }

    public String getXml() {
        return xml;
    }
 
    public Document getXmlDocument() throws ParserConfigurationException, UnsupportedEncodingException, SAXException {
        try {
            return builder.parse(new ByteArrayInputStream(xml.getBytes(encoding)));
        } catch (IOException ex) {
            // cannot happen
        }
        return null;
    }
    
      public Document getXmlDocumentWithoutLinebreakNodes() throws ParserConfigurationException, UnsupportedEncodingException, SAXException {
        try {
            return builder.parse(new ByteArrayInputStream(
                    xml.replaceAll(">( *\\n* *)*<", "><").getBytes(encoding)));
        } catch (IOException ex) {
            // cannot happen
        }
        return null;
    }

}
